package jp.hishidama.afwhs.java

import java.lang.reflect.Method

class CallScalaFunction(name: String, argc: Int) {
  private val (function, method) =
    try {
      val c = Class.forName(name)
      val f = c.newInstance()
      val m = c.getMethod("apply", Array.fill(argc)(classOf[Object]): _*)
      (f, m)
    } catch {
      case e: RuntimeException => throw e
      case e: Exception => throw new RuntimeException(e)
    }

  protected def apply[R](args: Object*): R = method.invoke(function, args: _*).asInstanceOf[R]
}
