package afwhs.sample

import jp.hishidama.afwhs._

object Sample1WordCount {
  def run(s1: Source[LineModel]) = {
    val split = s1.cogroup("split", "", Result[WordCountModel]("out")) {
      (s1, r1) =>
        s1.foreach {
          _.text.split("[ \t]+").foreach { w => r1.add(WordCountModel(w, 1)) }
        }
    }
    println(split)
    val count = split.cogroup("sum", "word", Result[WordCountModel]("out")) {
      (s1, r1) =>
        r1.add(WordCountModel(s1(0).word, s1.map(_.count).sum))
    }
    count
  }

  def main(args: Array[String]) {
    if (false) {
      val r = run(Source(LineModel("Hello World"),
        LineModel("Hello Asakusa"),
        LineModel("Hello Hadoop")))
      println(r)
    } else {
      val gen = new Generator("C:/workspace", "afws-wordcount", "afws.wordcount", "WordCount")
      val r = run(gen.newSource())
      gen.out(r)
      println(gen)
      gen.generateDmdl("afwhs_wordcount.dmdl")
      gen.generateOperator()
      gen.generateImporter()
      gen.generateExporter()
      gen.generateFlow()
    }
  }
}
