package jp.hishidama.afwhs

import jp.hishidama.afwhs.prove.ConvertNode

protected[afwhs] trait Convert[S0 <: Model] {
  s0: Source[S0] =>

  def convert[R0 <: Model](name: String)(f: (S0) => R0)(implicit cm: ClassManifest[R0]): (Source[R0], Source[S0]) = {
    val r0 = Result[R0]("out")
    val r1 = Result("original", this)

    this match {
      case g: WithGenerator if g.gen ne null =>
        g.gen.addNode(new ConvertNode(name, s0, r0, r1, f))
      case _ =>
        seq.foreach(s => r0.add(f(s)))
    }
    (r0, r1)
  }
}
