package jp.hishidama.afwhs

case class Key(val names: String*) {
  def this(name: String) = this((if (name.isEmpty) Seq.empty else name.split(",").toSeq): _*)
  def isEmpty = names.isEmpty

  def keyGetter[A](cm: ClassManifest[A]): A => Seq[Any] = {
    if (isEmpty) {
      (a: A) =>
        Seq.empty
    } else {
      val ms = names.map { cm.erasure.getMethod(_) }
      (a: A) =>
        ms.map { _.invoke(a) }
    }
  }

  def types[A](cm: ClassManifest[A]): Seq[Class[_]] = {
    names.map { cm.erasure.getMethod(_).getReturnType() }
  }

  override def toString(): String = {
    "Key(" + names.mkString(":") + ")"
  }

  def generate: String = {
    "@Key(group={" + (if (names.isEmpty) {
      ""
    } else {
      names.mkString("\"", "\",\"", "\"")
    }) + "})"
  }
}
