package jp.hishidama.afwhs

class Source[S0 <: Model](protected[afwhs] var seq: Seq[S0])(protected[afwhs] implicit val c0: ClassManifest[S0])
  extends CoGroup[S0] with Summarize[S0] with Convert[S0]
  with WithGenerator {
  s0 =>

  var flowName = ""
  var resultName = ""

  private[afwhs] def checkKeyType(ks: (Key, ClassManifest[_])*): Unit = {
    val (k0, c0) = ks.head
    val t0 = k0.types(c0)
    ks.tail.foreach {
      case (k, c) =>
        val t = k.types(c)
        if (t != t0) {
          throw new IllegalArgumentException("type mismatch:%s(%s), %s(%s)".format(k0, t0, k, c))
        }
    }
  }

  override def toString(): String = {
    if (gen eq null) {
      "Source++" + seq.toString()
    } else {
      "Source[" + c0 + "]"
    }
  }

  def modelClassName: String = {
    c0.erasure.getSimpleName()
  }
}

object Source {
  def apply[A <: Model: ClassManifest](args: A*) = new Source[A](args)
}
