package jp.hishidama.afwhs.gen

import jp.hishidama.afwhs._
import jp.hishidama.afwhs.prove._
import java.io.BufferedWriter

class DmdlGen(val name: String, val s: Source[_]) extends AnyRef with Util {
  var nodes = Seq.empty[Node]
  def addNode(node: Node) {
    nodes :+= node
  }

  def getSpecialNode: Option[Node] = {
    nodes.foreach {
      case n: SummarizeNode => return Some(n)
      case _ =>
    }
    None
  }

  def generate(w: BufferedWriter) {
    getSpecialNode match {
      case Some(n: SummarizeNode) =>
        val fname = createInstance(n.s.c0).asInstanceOf[Model].modelName
        w.write("summarized %s = %s => {\n".format(name, fname))
        val fs = getProperties(s.c0)
        fs.foreach { m =>
          val st = n.tsMap.apply(m.getName())
          w.write("  %s %s -> %s;\n".format(st.desc.toLowerCase(), st.name, st.to))
        }
        w.write("}")
        w.write(fs.map(f => n.tsMap(f.getName())).
          collect { case a: SAny => a.to }.
          mkString(" % ", ", ", ""))
        w.write(";\n")
      case _ =>
        w.write(name + " = {\n")
        getProperties(s.c0).foreach { m =>
          w.write("  %s : %s;\n".format(m.getName(), dmdlType(m.getReturnType())))
        }
        w.write("};\n")
    }
    w.write("\n")
  }
}
