package jp.hishidama.afwhs.gen
import jp.hishidama.afwhs.Generator
import java.io.BufferedWriter
import jp.hishidama.afwhs.Source

class ExporterGen(val gen: Generator) extends Gen {
  var packageName = "hogeexport"
  var className = "HogeExporter"

  var imports = Seq(
    gen.basePackage + ".modelgen.dmdl.model.*",
    "com.asakusafw.vocabulary.external.FileExporterDescription")

  def generate(w: BufferedWriter, s: Source[_]) {
    w.write("package " + packageName + ";\n\n")
    writeImport(w)
    w.write("\n")

    w.write("public class %sExporter extends FileExporterDescription {\n\n".format(s.modelClassName))

    w.write("""	@Override
	public Class<?> getModelType() {
		return %s.class;
	}
""".format(s.modelClassName))
    w.write("\n")

    w.write("""	@Override
	public String getPathPrefix() {
		return "output/%s-*";
	}
""".format(s.modelClassName))

    w.write("}\n")
  }
}