package jp.hishidama.afwhs.gen
import jp.hishidama.afwhs.Generator
import java.io.BufferedWriter
import jp.hishidama.afwhs.Source

class ImporterGen(val gen: Generator) extends Gen {
  var packageName = "hogeimport"

  var imports = Seq(
    "java.util.Set", "java.util.HashSet",
    gen.basePackage + ".modelgen.dmdl.model.*",
    "com.asakusafw.vocabulary.external.FileImporterDescription")

  def generate(w: BufferedWriter, s: Source[_]) {
    w.write("package " + packageName + ";\n\n")
    writeImport(w)
    w.write("\n")

    w.write("public class %sImporter extends FileImporterDescription {\n\n".format(s.modelClassName))

    w.write("""	@Override
	public Class<?> getModelType() {
		return %s.class;
	}
""".format(s.modelClassName))
    w.write("\n")

    w.write("""	@Override
	public Set<String> getPaths() {
		Set<String> set = new HashSet<String>();
		set.add("input/%s");
		return set;
	}
""".format(s.modelClassName))

    w.write("}\n")
  }
}