package jp.hishidama.afwhs.gen

import java.io.BufferedWriter
import scala.collection.mutable.LinkedHashMap
import jp.hishidama.afwhs.Generator

class OperatorGen(val gen: Generator) extends Gen {

  var imports = Seq(
    gen.basePackage + ".modelgen.dmdl.model.*",
    "com.asakusafw.vocabulary.operator.*")

  def generate(w: BufferedWriter) {
    gen.nodes.foreach { _.prepareGenerateOperator(this) }

    w.write("package " + gen.operatorPackage + ";\n\n")
    writeImport(w)
    w.write("\n")

    w.write("public abstract class " + gen.operatorClass + " {\n")
    gen.nodes.foreach { _.generateOperator(w, this) }
    w.write("}\n")
  }
}
