package jp.hishidama.afwhs.prove

import jp.hishidama.afwhs._
import java.io.BufferedWriter
import jp.hishidama.afwhs.gen.OperatorGen

class ConvertNode(
  name: String,
  s: Source[_ <: Model],
  r0: Result[_ <: Model],
  r1: Result[_ <: Model],
  f: AnyRef)
  extends Node(name, Seq(s), Seq(r0, r1), f) {

  override def toString(): String = {
    "ConvertNode(" + name + ", s=" + s + ", rs=" + rs + ")"
  }

  override def prepareGenerateOperator(gen: OperatorGen) {
    gen.imports ++= Seq(
      "jp.hishidama.afwhs.java.ConvertScalaFunction")
  }
  def generateOperator(w: BufferedWriter, gen: OperatorGen) {
    val fname = name + "$function"

    w.write("\n\t@Convert\n")
    w.write("\tpublic %s %s(%s arg) {\n".format(
      r0.modelClassName, name, s.modelClassName))

    w.write("\t\treturn (%s)%s.apply(arg);\n".format(r0.modelClassName, fname))

    w.write("\t}\n")

    w.append("\tprivate ConvertScalaFunction %s = new ConvertScalaFunction(\"%s\");\n".format(
      fname, f.getClass().getName()))
  }
}
