package jp.hishidama.afwhs.prove

import jp.hishidama.afwhs._
import java.io.BufferedWriter
import jp.hishidama.afwhs.gen.OperatorGen

class SummarizeNode(
  name: String,
  val ts: Seq[SummarizeType],
  val s: Source[_ <: Model],
  val r: Result[_ <: Model])
  extends Node(name, Seq(s), Seq(r), null) {

  override def toString(): String = {
    "SummarizeNode(" + name + ", ts=" + ts + ", s=" + s + ", r=" + r + ")"
  }

  lazy val tsMap = ts.map(t => t.to -> t).toMap

  def generateOperator(w: BufferedWriter, gen: OperatorGen) {
    w.write("\n\t@Summarize\n")
    w.write("\tpublic abstract %s %s(%s arg);\n".format(
      r.modelClassName, name, s.modelClassName))
  }
}
